' 

    MACRO define = MACRO

    TYPE OPENFILENAMEA
      lStructSize          as DWORD
      hwndOwner            as DWORD
      hInstance            as DWORD
      lpstrFilter          as DWORD
      lpstrCustomFilter    as DWORD
      nMaxCustFilter       as DWORD
      nFilterIndex         as DWORD
      lpstrFile            as DWORD
      nMaxFile             as DWORD
      lpstrFileTitle       as DWORD
      nMaxFileTitle        as DWORD
      lpstrInitialDir      as DWORD
      lpstrTitle           as DWORD
      Flags                as DWORD
      nFileOffset          as WORD
      nFileExtension       as WORD
      lpstrDefExt          as DWORD
      lCustData            as DWORD
      lpfnHook             as DWORD
      lpTemplateName       as DWORD
    END TYPE
    define OFNST = OPENFILENAMEA

    define path_size = 260

    define AZ = ASCIIZ
    define OFN_EXPLORER      = &H00080000
    define OFN_FILEMUSTEXIST = &H00001000
    define OFN_LONGNAMES     = &H00200000
    define OFN_HIDEREADONLY  = &H00000004

    DECLARE FUNCTION GetOpenFileDialog LIB "COMDLG32.DLL" _
                     ALIAS "GetOpenFileNameA"(lpofn AS OFNST) AS LONG
    DECLARE FUNCTION GetSaveFileDialog LIB "COMDLG32.DLL" _
                     ALIAS "GetSaveFileNameA"(lpofn AS OFNST) AS LONG

' 

FUNCTION OpenFileDialog(ByVal iinstance as DWORD, _
                        ByVal hParent   as DWORD, _
                        szbuffer        as ASCIIZ, _
                        sztitle         as ASCIIZ, _
                        szfilter        as ASCIIZ) as DWORD

    LOCAL cdir as ASCIIZ * %MAX_PATH
    LOCAL ofn  as OPENFILENAMEA

    GetCurrentDirectory %MAX_PATH,cdir

    ofn.lStructSize = SIZEOF(OPENFILENAMEA)
    ofn.hWndOwner   = hParent
    ofn.hInstance   = iinstance
    ofn.lpstrFilter = VarPtr(szfilter)
    ofn.lpstrFile   = VarPtr(szbuffer)
    ofn.nMaxFile    = %MAX_PATH
    ofn.lpstrTitle  = VarPtr(sztitle)
    ofn.lpstrInitialDir = VarPtr(cdir)
    ofn.Flags       = OFN_EXPLORER or OFN_FILEMUSTEXIST or _
                      OFN_LONGNAMES or OFN_HIDEREADONLY

    FUNCTION = GetOpenFileDialog(ofn)

End FUNCTION

' 

FUNCTION SaveFileDialog(ByVal iinstance as DWORD, _
                        ByVal hParent   as DWORD, _
                        szbuffer        as ASCIIZ, _
                        sztitle         as ASCIIZ, _
                        szfilter        as ASCIIZ) as DWORD

    LOCAL cdir as ASCIIZ * %MAX_PATH
    LOCAL ofn  as OPENFILENAMEA

    GetCurrentDirectory %MAX_PATH,cdir

    ofn.lStructSize = SIZEOF(OPENFILENAMEA)
    ofn.hWndOwner   = hParent
    ofn.hInstance   = iinstance
    ofn.lpstrFilter = VarPtr(szfilter)
    ofn.lpstrFile   = VarPtr(szbuffer)
    ofn.nMaxFile    = %MAX_PATH
    ofn.lpstrTitle  = VarPtr(sztitle)
    ofn.lpstrInitialDir = VarPtr(cdir)
    ofn.Flags       = OFN_EXPLORER or OFN_LONGNAMES or OFN_HIDEREADONLY
                      
    FUNCTION = GetSaveFileDialog(ofn)

End FUNCTION

' 
