' 
'                       single instance text editor
' 

    %usemacros = 1

    #INCLUDE "MONOTXT.INC"

' 

FUNCTION PBmain() AS LONG

    LOCAL  Wid            as LONG
    LOCAL  Hgt            as LONG
    LOCAL  wcex           as WNDCLASSEX
    LOCAL  szClassName    as STRING * 32

    szDisplayName = "Untitled"
    szClassName   = "mono_txt_Class"
    hInstance     = GetModuleHandle(ByVal %NULL)

  ' -----------------------
  ' set global search flags
  ' -----------------------
    sch_direction = 1       ' 0 = backwards, 1 = forward
    sch_matchcase = 1       ' 0 = no, 1 = yes
    sch_wholeword = 0       ' 0 = no, 1 = yes
    sch_exclusion = 0       ' flag to exclude 2nd dialog from running
    sch_replace   = 0       ' the replace flag

    Sw = GetSystemMetrics(%SM_CXSCREEN)     ' get the screen X and Y size
    Sh = GetSystemMetrics(%SM_CYSCREEN)

    hIcon   = LoadIcon(hInstance,ByVal 5)   ' get system icon and cursor handles
    hCursor = LoadCursor(%NULL,ByVal %IDC_ARROW)

  ' ---------------------------------------------------------------------
  ' preload the WNDCLASSEX structure with arguments for RegisterClassEx()
  ' ---------------------------------------------------------------------
    wcex.cbSize        = SIZEOF(wcex)
    wcex.style         = %CS_BYTEALIGNCLIENT or %CS_BYTEALIGNWINDOW
    wcex.lpfnWndProc   = CODEPTR(WndProc)
    wcex.cbClsExtra    = 0
    wcex.cbWndExtra    = 0
    wcex.hInstance     = hInstance
    wcex.hIcon         = hIcon
    wcex.hCursor       = hCursor
    wcex.hbrBackground = %NULL
    wcex.lpszMenuName  = %NULL
    wcex.lpszClassName = VarPtr(szClassName)
    wcex.hIconSm       = %NULL

    RegisterClassEx wcex                ' register the window class

  ' ----------------------------------------------------------
  ' limits the window aspect ratio to no greater that 1.4 to 1
  ' ----------------------------------------------------------
    Hgt = Sh * .75
    If Sw * .75 > (Sh * .70) Then
      Wid = Hgt * 1.4
    Else
      Wid = Sw * .75   ' Set width & height to percentage of screen size.
    End If
  ' ----------------------------------------------------------

    hWnd = CreateWindowEx( _
                        %WS_EX_LEFT, _                  ' extended style
                        ByVal VarPtr(szClassName), _    ' window class name
                        szDisplayName, _                ' window title
                        %WS_OVERLAPPEDWINDOW, _         ' window style
                        Sw\2-(Wid\2), _                 ' initial x position
                        Sh\2-(Hgt\2), _                 ' initial y position
                        Wid, _                          ' initial x size
                        Hgt, _                          ' initial y size
                        %NULL, _                        ' parent window handle
                        %NULL, _                        ' window menu handle
                        hInstance, _                    ' program instance handle
                        ByVal %NULL)                    ' creation parameters

    hMnu = LoadMenu(hInstance,ByVal 10)
    SetMenu hWnd, hMnu

    ShowWindow hWnd, %SW_SHOW
    UpdateWindow hWnd

    FUNCTION = MessageLoop              ' call the remote message loop function

END FUNCTION

' 

FUNCTION MessageLoop as DWORD

    #REGISTER NONE

    LOCAL  rv   as LONG
    GLOBAL pmsg as DWORD                                ' MSG struct pointer
    GLOBAL MSG  as tagMSG                               ' MSG structure

    pmsg = VarPtr(MSG)

  MsgLoop:
    GetMessage ByVal pmsg,%NULL,0,0
    ! test eax, eax
    ! jz lpout

    Select case as LONG MSG.message
      Case %WM_KEYUP
      ' ---------------------
      ' process normal F keys
      ' ---------------------
        Select Case as LONG MSG.wParam
          Case %VK_F1

          Case %VK_F2
            SendMessage hWnd,%WM_COMMAND,1110,0         ' search dialog
          Case %VK_F3
            SendMessage hWnd,%WM_COMMAND,1111,0         ' replace dialog
          Case %VK_F4
            SendMessage hWnd,%WM_COMMAND,1106,0         ' select all

        End Select

      ' --------------------------------
      ' Test if the CTRL key is pressed
      ' --------------------------------
          rv = GetAsyncKeyState(%VK_CONTROL)   ' ------------------ CONTROL
          ! cmp WORD PTR rv[2], &B1111111111111111
          ! jne lbl0

        ' -----------------------------------------
        ' Defeat the following Richedit Ctrl+ keys
        ' -----------------------------------------
        Select Case as LONG MSG.wParam
          Case 77, 109
            ! jmp MsgLoop   ' Ctrl+M
          Case 73, 105
            ! jmp MsgLoop   ' Ctrl+I

        ' ------------------
        ' file menu hot keys
        ' ------------------
          Case 78, 110      ' ctrl + N new file
            SendMessage hWnd,%WM_COMMAND,1000,0
            ! jmp MsgLoop

          Case 87, 119      ' ctrl + W new window
            SendMessage hWnd,%WM_COMMAND,1001,0
            ! jmp MsgLoop

          Case 79, 111      ' ctrl + O open file
            SendMessage hWnd,%WM_COMMAND,1010,0
            ! jmp MsgLoop

          Case 83, 115      ' ctrl + S save file
            SendMessage hWnd,%WM_COMMAND,1020,0
            ! jmp MsgLoop

          Case 65, 97       ' ctrl + A save file as
            SendMessage hWnd,%WM_COMMAND,1021,0
            ! jmp MsgLoop

          Case 81, 113      ' ctrl + Q save file as
            SendMessage hWnd,%WM_COMMAND,1098,0
            ! jmp MsgLoop

        ' ---------------------------------------------
        ' edit menu hot keys. Some windows versions of
        ' richedit are not reliable with the built in
        ' hotkeys so enforce standard behaviour of edit
        ' control across different windows versions
        ' ---------------------------------------------
          Case 85, 117      ' ctrl + U  undo
            SendMessage hEdit,%EM_UNDO,0,0
            ! jmp MsgLoop

          Case 82, 114      ' ctrl + R  redo
            SendMessage hEdit,%EM_REDO,0,0
            ! jmp MsgLoop

          Case 90, 122      ' Ctrl + X cut
            SendMessage hEdit,%WM_CUT,0,0
            ! jmp MsgLoop

          Case 67, 99       ' Ctrl + C copy
            SendMessage hEdit,%WM_COPY,0,0
            ! jmp MsgLoop

          Case 86, 118      ' Ctrl + V paste
            SendMessage hEdit,%EM_PASTESPECIAL,%CF_TEXT,0
            ! jmp MsgLoop

          Case 71, 103      ' Ctrl + G goto line number
            SendMessage hWnd,%WM_COMMAND,1107,0
            ! jmp MsgLoop

        End Select
        lbl0:

    End Select

    TranslateMessage ByVal pmsg         ' translate any virtual-key messages
    DispatchMessage  ByVal pmsg         ' dispatch message to the nominated WndProc address
    ! jmp MsgLoop
  lpout:

    FUNCTION = Msg.wParam

END FUNCTION

' 

FUNCTION WndProc(ByVal hWin   as LONG, _
                 ByVal Msg    as LONG, _
                 ByVal wParam as LONG, _
                 ByVal lParam as LONG) as LONG

    LOCAL sflag as DWORD
    LOCAL rct   as RECT
    LOCAL pthbuffer as ASCIIZ * %MAX_PATH

    Select Case as LONG Msg             ' force integer testing of messages

      Case %WM_SETFOCUS
        SetFocus hEdit

      Case %WM_COMMAND
        Select Case as LONG wParam
          Case 1000     ' ----------------------------- New File
            If SendMessage(hEdit,%EM_GETMODIFY,0,0) <> 0 Then
              If DialogBox(hInstance,ByVal 2000,0,CodePtr(Confirm_Proc)) = 1 Then             ' YES button
                GetWindowText hWnd,ByVal VarPtr(pthbuffer),%MAX_PATH
                If pthbuffer = szDisplayName Then
                  pthbuffer = ""
                  SaveFileDialog hInstance,hWin,ByVal VarPtr(pthbuffer), _
                                 "Save File",ByVal VarPtr(fPattern)
                  If pthbuffer = "" Then Exit FUNCTION
                  Write_Disk_File ByVal VarPtr(pthbuffer)
                End If
                Write_Disk_File ByVal varPtr(pthbuffer)
              End If
            End If

            SetWindowText hEdit,ByVal %NULL
            SetWindowText hWin,ByVal varPtr(szDisplayName)

          Case 1001     ' ----------------------------- New Window
            GetModuleFileName ByVal %NULL,ByVal varPtr(pthbuffer),%MAX_PATH
            ShellExecute hWnd,"open",ByVal VarPtr(pthbuffer), _
                         ByVal %NULL,ByVal %NULL,%SW_SHOW

          Case 1010     ' ----------------------------- Open File
            If SendMessage(hEdit,%EM_GETMODIFY,0,0) <> 0 Then
              If DialogBox(hInstance,ByVal 2000,0,CodePtr(Confirm_Proc)) = 1 Then             ' YES button
                GetWindowText hWnd,ByVal VarPtr(pthbuffer),%MAX_PATH
                If pthbuffer = szDisplayName Then
                  pthbuffer = ""
                  SaveFileDialog hInstance,hWin,ByVal VarPtr(pthbuffer), _
                                 "Save File",ByVal VarPtr(fPattern)
                  If pthbuffer = "" Then Exit FUNCTION
                  Write_Disk_File ByVal VarPtr(pthbuffer)
                End If
                Write_Disk_File ByVal varPtr(pthbuffer)
              End If
            End If

            pthbuffer = ""
            OpenFileDialog hInstance,hWin,ByVal VarPtr(pthbuffer), _
                           "Open File",ByVal VarPtr(fPattern)
            If pthbuffer = "" Then Exit FUNCTION
            Read_Disk_File ByVal VarPtr(pthbuffer)

          Case 1020     ' ----------------------------- Save File
            GetWindowText hWnd,ByVal VarPtr(pthbuffer),%MAX_PATH
            If pthbuffer = szDisplayName Then
              goto save_file_as
            End If
            Write_Disk_File ByVal varPtr(pthbuffer)

          Case 1021     ' ----------------------------- Save File As
          save_file_as:
            pthbuffer = ""
            SaveFileDialog hInstance,hWin,ByVal VarPtr(pthbuffer), _
                           "Save File",ByVal VarPtr(fPattern)
            If pthbuffer = "" Then Exit FUNCTION
            Write_Disk_File ByVal VarPtr(pthbuffer)

          Case 1098     ' ----------------------------- Close Editor
            SendMessage hWin,%WM_SYSCOMMAND,%SC_CLOSE,0

          Case 1099     ' ----------------------------- About Box
            DialogBox(hInstance,ByVal 6000,hWnd,CodePtr(About_Proc))

        ' ---------
        ' edit menu
        ' ---------
          Case 1100
            SendMessage hEdit,%EM_UNDO,0,0
          Case 1101
            SendMessage hEdit,%EM_REDO,0,0
          Case 1102
            SendMessage hEdit,%WM_CUT,0,0
          Case 1103
            SendMessage hEdit,%WM_COPY,0,0
          Case 1104
            SendMessage hEdit,%EM_PASTESPECIAL,%CF_TEXT,0
          Case 1105
            SendMessage hEdit,%WM_CLEAR,0,0
          Case 1106
            SelectAll
          Case 1107
            DialogBox(hInstance,ByVal 5000,hWnd,CodePtr(goto_line))

          Case 1110
            If sch_exclusion = 1 Then
              Exit FUNCTION
            End If
            sch_exclusion = 1
            CreateDialogParam hInstance,ByVal 3000,hWnd,CodePtr(Find_Proc),0        ' trailing 0 means search only
          Case 1111
            If sch_exclusion = 1 Then
              Exit FUNCTION
            End If
            sch_exclusion = 1
            sch_replace   = 1
            CreateDialogParam hInstance,ByVal 4000,hWnd,CodePtr(Find_Proc),1        ' trailing 1 means replace as well
        End Select

      Case %WM_CREATE
      ' ------------------------------------------------------
      ' create a ZERO seperated double ZERO terminated list of
      ' string pairs in the format required by the Windows API
      ' functions for the two file common dialogs.
      ' ------------------------------------------------------
        fPattern = chr$("All Files",0,"*.*",0, _
                        "Txt Files",0,"*.txt",0, _
                        "Ini Files",0,"*.ini",0,0)

        LoadLibrary "RICHED20.DLL"
        hEdit = RichEdit(hWin,0,0,100,100,1234)
        SendMessage hEdit,%EM_EXLIMITTEXT,0,-1
        SendMessage hEdit,%EM_SETOPTIONS,%ECOOP_XOR,%ECO_SELECTIONBAR
        SendMessage hEdit,%EM_SETTEXTMODE,%TM_PLAINTEXT or _
                          %TM_MULTILEVELUNDO or %TM_MULTICODEPAGE, 0

        SendMessage hEdit,%WM_SETFONT,GetStockObject(%SYSTEM_FIXED_FONT),%TRUE

      Case %WM_SIZE
        GetClientRect hWin,ByVal VarPtr(rct)
        MoveWindow hEdit,0,0,rct.nRight,rct.nBottom,%TRUE

      Case %WM_CLOSE
        If SendMessage(hEdit,%EM_GETMODIFY,0,0) <> 0 Then                       ' test if modified flag set
          GetWindowText hWnd,ByVal VarPtr(pthbuffer),%MAX_PATH                  ' get file name from titlebar
          If DialogBox(hInstance,ByVal 2000,0,CodePtr(Confirm_Proc)) = 1 Then   ' get confirmation
            If pthbuffer = szDisplayName Then                                   ' if "Untitled"
              pthbuffer = ""                                                    ' zero the buffer
              SaveFileDialog hInstance,hWin,ByVal VarPtr(pthbuffer), _
                             "Save File",ByVal VarPtr(fPattern)                 ' call the file save dialog
              If pthbuffer = "" Then                                            ' if user clicked cancel
                ! jmp close_out                                                 ' exit without writing changes
              End If
            End If
          End If
        End If

        Write_Disk_File ByVal VarPtr(pthbuffer)                                 ' write file to disk

      close_out:

      Case %WM_DESTROY
        PostQuitMessage 0               ' terminate the message loop

    END Select

    FUNCTION = DefWindowProc(hWin,Msg,wParam,lParam)

END FUNCTION

' 

FUNCTION RichEdit(hParent as LONG, tx as LONG, ty as LONG, _
                       wd as LONG, ht as LONG, ID as LONG) as LONG

    LOCAL handl as DWORD

    handl = CreateWindowEx(%WS_EX_STATICEDGE,"RichEdit20a",ByVal %NULL, _
                 %WS_VISIBLE or %WS_CHILDWINDOW or _
                 %ES_MULTILINE or %WS_VSCROLL or %WS_HSCROLL or _
                 %ES_AUTOHSCROLL or %ES_AUTOVSCROLL or %ES_NOHIDESEL or _
                 %WS_CLIPSIBLINGS, _
                 tx,ty,wd,ht,hParent,ID,hInstance,ByVal %NULL)

    FUNCTION = handl

END FUNCTION

' 

SUB Read_Disk_File(ByVal pName as DWORD)

    LOCAL hFile     as LONG
    LOCAL br        as DWORD
    LOCAL ofs       as OFSTRUCT
    LOCAL es        as EDITSTREAM

    hFile = CreateFile(ByVal pName,%GENERIC_READ,%FILE_SHARE_READ,ByVal %NULL, _
                       %OPEN_EXISTING,%FILE_FLAG_POSIX_SEMANTICS,ByVal %NULL)

    es.dwCookie    = hFile
    es.dwError     = 0
    es.pfnCallback = CodePtr(ofCallBack)
    br = SendMessage(hEdit,%EM_STREAMIN,%SF_TEXT,ByVal VarPtr(es))

    CloseHandle hFile
    SetWindowText hWnd,ByVal pName
    SendMessage hEdit,%EM_SETMODIFY,%FALSE,0

END SUB

' 

SUB Write_Disk_File(ByVal pName as DWORD)

    LOCAL hFile     as LONG
    LOCAL br        as DWORD
    LOCAL ofs       as OFSTRUCT
    LOCAL es        as EDITSTREAM

    hFile = CreateFile(ByVal pName,%GENERIC_WRITE,%FILE_SHARE_WRITE,ByVal %NULL, _
                       %CREATE_ALWAYS,%FILE_FLAG_POSIX_SEMANTICS,ByVal %NULL)

    es.dwCookie    = hFile
    es.dwError     = 0
    es.pfnCallback = CodePtr(sfCallBack)
    SendMessage hEdit,%EM_STREAMOUT,%SF_TEXT,ByVal VarPtr(es)

    CloseHandle hFile
    SetWindowText hWnd,ByVal pName
    SendMessage hEdit,%EM_SETMODIFY,%FALSE,0

END SUB

' 

FUNCTION ofCallBack(ByVal dwCookie as LONG, ByVal pbBuff as LONG, _
                    ByVal cb as LONG,ByVal pcb as LONG PTR) as LONG

    rv& = ReadFile(dwCookie,ByVal pbBuff,cb,@pcb,ByVal %NULL)

    FUNCTION = 0

END FUNCTION

' 

FUNCTION sfCallBack(ByVal dwCookie as LONG, ByVal pbBuff as LONG, _
                    ByVal cb as LONG,ByVal pcb as LONG PTR) as LONG

    rv& = WriteFile(dwCookie,ByVal pbBuff,cb,@pcb,ByVal %NULL)

    FUNCTION = 0

END FUNCTION

' 

FUNCTION Confirm_Proc(ByVal hDlg   as LONG, _
                      ByVal Msg    as LONG, _
                      ByVal wParam as LONG, _
                      ByVal lParam as LONG) as LONG

  ' ---------------------------------------------------
  ' message processing for the file confirmation dialog
  ' ---------------------------------------------------
    Select Case as LONG Msg             ' process messages as integers

      Case %WM_COMMAND
        Select Case as LONG wParam
          Case 2010                     ' the "YES" button
            EndDialog hDlg, 1           ' return "1" on YES
          Case 2011                     ' the "NO" button
            EndDialog hDlg, 0           ' return ZERO on NO
        End Select

      Case %WM_CLOSE                    ' the system close button
         EndDialog hDlg, 0

    END Select

    FUNCTION = 0

END FUNCTION

' 

FUNCTION About_Proc(ByVal hDlg   as LONG, _
                    ByVal Msg    as LONG, _
                    ByVal wParam as LONG, _
                    ByVal lParam as LONG) as LONG

  ' ---------------------------------------------------
  ' message processing for the about dialog
  ' ---------------------------------------------------
    Select Case as LONG Msg             ' process messages as integers

      Case %WM_COMMAND
        Select Case as LONG wParam
          Case %IDOK
            EndDialog hDlg, 0
        End Select

      Case %WM_CLOSE                    ' the system close button
         EndDialog hDlg, 0

    END Select

    FUNCTION = 0

END FUNCTION

' 

FUNCTION goto_line(ByVal hDlg   as LONG, _
                   ByVal Msg    as LONG, _
                   ByVal wParam as LONG, _
                   ByVal lParam as LONG) as LONG

  ' -------------------------------------------
  ' message processing for the goto line dialog
  ' -------------------------------------------
    LOCAL tl    as DWORD
    LOCAL li    as DWORD
    LOCAL ll    as DWORD
    LOCAL lcnt  as DWORD
    LOCAL ucnt  as DWORD
    LOCAL pstr  as DWORD
    LOCAL psrc  as DWORD
    LOCAL cr    as CHARRANGE
    LOCAL buffer as ASCIIZ * 64
    LOCAL leadin as ASCIIZ * 64

    Select Case as LONG Msg                 ' process messages as integers

      Case %WM_INITDIALOG
        Editgt = GetDlgItem(hDlg,100)       ' text entry for line number
        Statgt = GetDlgItem(hDlg,101)       ' static cotrol for display of line count
        lpEditgtProc = SetWindowLong(Editgt,%GWL_WNDPROC,_
                                     ByVal CodePtr(EditgtProc)) ' subclass the edit control
        lcnt = SendMessage(hEdit,%EM_GETLINECOUNT,0,0)          ' rich edit line count
        psrc = VarPtr(leadin)
        pstr = VarPtr(buffer)
        leadin = "Editor has "
        ltoa lcnt,ByVal pstr,10             ' MSVCRT ltoa function
        strcat ByVal psrc,ByVal pstr        ' MSVCRT strcat function
        buffer = " lines"                   ' reuse buffer
        strcat ByVal psrc,ByVal pstr        ' MSVCRT strcat function
        SetWindowText Statgt,ByVal psrc     ' display the editor's line count

        FUNCTION = 1
        Exit FUNCTION

      Case %WM_COMMAND
        Select Case as LONG wParam
          Case %IDOK
            pstr = VarPtr(buffer)
            tl   = GetWindowTextLength(Editgt)
            If tl = 0 Then
              FUNCTION = 0
              Exit FUNCTION
            End If
            GetWindowText Editgt,ByVal pstr,64
            lcnt = SendMessage(hEdit,%EM_GETLINECOUNT,0,0)          ' rich edit line count
            ucnt = atol(ByVal pstr)         ' MSVCRT atol fuction

            If ucnt > lcnt Then
              MessageBox hDlg,"Editor does not have that many lines","Sorry ...",%MB_OK
              FUNCTION = 0
              Exit FUNCTION
            End If

            ! sub ucnt, 1
            li = SendMessage(hEdit,%EM_LINEINDEX,ucnt,0)
            cr.cpMin = li
            cr.cpMax = li
            SendMessage hEdit,%EM_EXSETSEL,0,ByVal VarPtr(cr)
            ll = SendMessage(hEdit,%EM_LINELENGTH,cr.cpMin,0)
            cr.cpMax = cr.cpMax + ll
            SendMessage hEdit,%EM_EXSETSEL,0,ByVal VarPtr(cr)

            EndDialog hDlg, 0

          Case %IDCANCEL
            EndDialog hDlg, 0
        END Select


      Case %WM_CLOSE                        ' the system close button
         EndDialog hDlg, 0

    END Select

    FUNCTION = 0

END FUNCTION

' 

FUNCTION EditgtProc( _
              ByVal hCtl   as LONG, _
              ByVal Msg    as LONG, _
              ByVal wParam as LONG, _
              ByVal lParam as LONG) as LONG

    Select Case as LONG Msg
    ' --------------------------------
    ' allow numbers and backspace only
    ' --------------------------------
      Case %WM_CHAR
        Select Case as LONG wParam
          Case 13
            SendMessage GetParent(hCtl),%WM_COMMAND,%IDOK,0
            FUNCTION = 0
            Exit FUNCTION
          Case 8,48 to 57
            ' do nothing and accept keys 0 to 9 and backspace
          Case Else
            ' throw the rest away
            FUNCTION = 0
            Exit FUNCTION
        End Select

    End Select

  FUNCTION = CallWindowProc(ByVal lpEditgtProc,hCtl,Msg,wParam,lParam)

END FUNCTION

' 

FUNCTION Find_Proc(ByVal hDlg   as LONG, _
                   ByVal Msg    as LONG, _
                   ByVal wParam as LONG, _
                   ByVal lParam as LONG) as LONG

  ' -------------------------------------------------------------
  ' this dialog procedure is used by both the search and replace
  ' dialogs. The REPLACE dialog passes a "1" as the lParam of the
  ' WM_INITDIALOG to indicate that the REPLACE dialog is being
  ' used instead of the SEARCH dialog.
  '
  ' a variable "sch_replace" is also used so it has scope in the
  ' subclass for the two edit controls in the REPLACE dialog.
  ' -------------------------------------------------------------

    #REGISTER NONE

  ' -------------------------------------------
  ' message processing for the find text dialog
  ' -------------------------------------------
    LOCAL sOpt    as DWORD
    LOCAL tpos    as LONG
    LOCAL sLen1   as DWORD
    LOCAL sLen2   as DWORD

    LOCAL buffer1 as STRING * 128
    LOCAL buffer2 as STRING * 128
    LOCAL ftxt    as FINDTEXTAPI
    LOCAL cr      as CHARRANGE

    Select Case as LONG Msg             ' process messages as integers

      Case %WM_INITDIALOG
      ' --------------------------------------
      ' get the window handle for each control
      ' --------------------------------------
        Edit1 = GetDlgItem(hDlg,100)    ' search text edit control

        lpEdit1Proc = SetWindowLong(Edit1,%GWL_WNDPROC,_
                                    ByVal CodePtr(Edit1Proc))

        Edit2 = 0                       ' set to zero as flag

        If lParam = 1 Then
          Edit2 = GetDlgItem(hDlg,110)  ' include if replace dialog
          lpEdit1Proc = SetWindowLong(Edit2,%GWL_WNDPROC,_
                                      ByVal CodePtr(Edit1Proc))
        End If

        hchk1 = GetDlgItem(hDlg,103)    ' FR_MATCHCASE checkbox
        hchk2 = GetDlgItem(hDlg,104)    ' FR_WHOLEWORD checkbox
        hrad1 = GetDlgItem(hDlg,105)    ' UP radio button
        hrad2 = GetDlgItem(hDlg,106)    ' DOWN radio button

      ' -------------------------------------
      ' set the radio buttons and check boxes
      ' -------------------------------------
        If sch_direction = 0 Then
          SendMessage hrad1,%BM_SETCHECK,%BST_CHECKED,0
        Else
          SendMessage hrad2,%BM_SETCHECK,%BST_CHECKED,0
        End If

        If sch_wholeword <> 0 Then
          SendMessage hchk1,%BM_SETCHECK,%BST_CHECKED,0
        End If

        If sch_matchcase <> 0 Then
          SendMessage hchk2,%BM_SETCHECK,%BST_CHECKED,0
        End If

      Case %WM_COMMAND
        Select Case as LONG wParam
          Case 101                      ' Find Next
        ' ************************************************************************

          ' -----------------------------------------------
          ' set the search flags based on the user options.
          ' the direct numbers are used instead of the
          ' equates to avoid including the bloat in the
          ' common dialog include file.
          ' -----------------------------------------------
            If sch_direction <> 0 Then
              sOpt = 1          ' search backwards          %FR_DOWN      
            Else
              sOpt = 0          ' search forward
            End If

            If sch_matchcase <> 0 Then
              ! or sOpt, 4      ' case sensitive search     %FR_MATCHCASE 
            End if

            If sch_wholeword <> 0 Then
              ! or sOpt, 2      ' only match whole word     %FR_WHOLEWORD
            End If
          ' -----------------------------------------------

            sLen1 = GetWindowText(Edit1,ByVal VarPtr(buffer1),128)

            If sLen1 = 0 Then
              Exit FUNCTION
            End If

            SendMessage hEdit,%EM_EXGETSEL,0,ByVal VarPtr(cr)

            cr.cpMin = cr.cpMin + 1         ' increment up 1 character
                                            ' from current selection
            ftxt.chrg.cpMin = cr.cpMin
            ftxt.chrg.cpMax = SendMessage(hEdit,%WM_GETTEXTLENGTH,0,0)
            ftxt.lpstrText  = VarPtr(buffer1)

            tpos = SendMessage(hEdit,%EM_FINDTEXT,sOpt,ByVal VarPtr(ftxt))

            If tpos = -1 Then
              If Edit2 = 0 Then
                MessageBox hDlg,"No further matches found","Find Text",%MB_OK
                Exit FUNCTION
              Else
                MessageBox hDlg,"No further matches found","Replace Text",%MB_OK
                Exit FUNCTION
              End If
            End If

          ' ----------------------------------------
          ' set beginning and end of text to hilight
          ' ----------------------------------------
            cr.cpMin = tpos
            cr.cpMax = tpos
            cr.cpMax = cr.cpMax + sLen1

          ' ----------------
          ' hilight the text
          ' ----------------
            SendMessage hEdit,%EM_EXSETSEL,0,ByVal varPtr(cr)

        ' ************************************************************************

          Case 102                      ' Close
            ! jmp close_msg

        ' -----------------------------------------------------------
        ' set the check boxes and radio buttons values to user choice
        ' -----------------------------------------------------------
          Case 103              ' match case check box
            If SendMessage(hchk1,%BM_GETCHECK,0,0) = 0 Then
              sch_matchcase = 0
            Else
              sch_matchcase = 1
            End If

            ! jmp check_focus

          Case 104              ' whole word check box
            If SendMessage(hchk2,%BM_GETCHECK,0,0) = 0 Then
              sch_wholeword = 0
            Else
              sch_wholeword = 1
            End If

            ! jmp check_focus

          Case 105              ' search forwards radio button
            sch_direction = 0

            ! jmp check_focus

          Case 106              ' search backwards radio button
            sch_direction = 1

          check_focus:
            If sch_replace = 0 Then
              SetFocus Edit1
            Else
              If GetWindowTextLength(Edit1) <> 0 Then
                SetFocus Edit1
              Else
                SetFocus Edit2
              End if
            End If

        ' ----------------------------------------------------

          Case 115              ' the REPLACE button
            sLen2 = GetWindowText(Edit2,ByVal VarPtr(buffer2),128)

            SendMessage hEdit,%EM_EXGETSEL,0,ByVal VarPtr(cr)

          ' -------------------------------------------
          ' exclude null selection and null replacement
          ' -------------------------------------------
            If cr.cpMin <> cr.cpMax Then
              If sLen2 <> 0 Then
                SendMessage hEdit,%EM_REPLACESEL,%TRUE,ByVal VarPtr(buffer2)
              End if
            End If

            SetFocus Edit2

        End Select

      Case %WM_CLOSE            ' the system close button
        close_msg:
          sch_replace = 0
          sch_exclusion = 0
          EndDialog hDlg, 0

    END Select

    FUNCTION = 0

END FUNCTION

' 

FUNCTION Edit1Proc( _
              ByVal hCtl   as LONG, _
              ByVal Msg    as LONG, _
              ByVal wParam as LONG, _
              ByVal lParam as LONG) as LONG

  ' ----------------------------------------------
  ' use a common subclass for both edit controls
  ' in the dialog procedure above used by both
  ' search and replace dialogs.
  ' select the edit control by its handle then
  ' process the WM_CHAR ascii 13 for each control.
  ' ----------------------------------------------

    #REGISTER NONE

    Select Case as LONG hCtl
      Case Edit1
        Select Case as LONG Msg
          Case %WM_CHAR
            Select Case as LONG wParam
              Case 13
                If sch_replace = 1 Then
                  If GetWindowTextLength(Edit1) <> 0 Then
                    SetFocus Edit2
                  End If
                Else
                  If GetWindowTextLength(Edit1) <> 0 Then
                    SendMessage GetParent(hCtl),%WM_COMMAND,101,0
                    SetFocus Edit1
                  End If
                End If
            End Select
        End Select

      Case Edit2
        Select Case as LONG Msg
          Case %WM_CHAR
            Select Case as LONG wParam
              Case 13
                If GetWindowTextLength(Edit1) = 0 Then
                  SetFocus Edit1
                  Exit FUNCTION
                End If
                If GetWindowTextLength(Edit2) = 0 Then
                  SetFocus Edit2
                  Exit FUNCTION
                End If
                SendMessage GetParent(hCtl),%WM_COMMAND,101,0
                SetFocus Edit2
            End Select
        End Select

    End Select

    FUNCTION = CallWindowProc(ByVal lpEdit1Proc,hCtl,Msg,wParam,lParam)

END FUNCTION

' 

SUB SelectAll

    LOCAL cr as CHARRANGE

    cr.cpMin = 0
    cr.cpMax = GetWindowTextLength(hEdit)

    SendMessage hEdit,%EM_EXSETSEL,0,ByVal VarPtr(cr)

END SUB

' 
